/***** generateQuerySbjct.c ***********************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Tue Sep 13 10:23:29 2011
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "interface.h"
#include "eprintf.h"

void generateSample(Args *args);

int main(int argc, char *argv[]){
  char *version;
  Args *args;

  version = "0.4";
  setprogname2("generateQuerySbjct");
  args = getArgs(argc, argv);
  if(args->h || args->e)
    printUsage(version);
  if(args->v)
    printSplash(version);
  generateSample(args);
  free(args);
  free(progname());
  return 0;
}

void generateSample(Args *args){
  FILE *pfp, *qfp, *sfp;
  char *template1, *template2, *template3, *cmd;
  char *buf;
  int bufSize, numSeq;

  bufSize = 1000;
  buf = (char *)emalloc(sizeof(char)*bufSize);

  template1 = "ms 2 1 -s %d -r %f %d | ms2dna -g %f";
  template2 = "ms 2 1 -t %f -r %f %d | ms2dna -g %f";
  template3 = "macs 2 %d -t %f -r %f 2>/dev/null | msformatter | ms2dna -a -g %f";
  cmd = (char *)emalloc(sizeof(char)*bufSize);
  if(args->s)
    sprintf(cmd,template1,args->s,args->r,args->l,args->g);
  else{
    if(args->a){
      sprintf(cmd,template3,args->l,args->t/args->l,args->r/args->l,args->g);
    }else
      sprintf(cmd,template2,args->t,args->r,args->l,args->g);
  }
  if((pfp = popen(cmd,"r")) == NULL){
    printf("ERROR[generateQuerySbjct]: Could not open pipe for command '%s'.\n",cmd);
    exit(-1);
  }
  if((qfp = fopen(args->q,"w")) == NULL){
    printf("ERROR[generateQuerySbjct] Could not open '%s' for writing query sequence to.\n",args->q);
    exit(-1);
  }
  if((sfp = fopen(args->S,"w")) == NULL){
    printf("ERROR[generateQuerySbjct] Could not open '%s' for writing sbjct sequence to.\n",args->S);
    exit(-1);
  }
  numSeq = 0;
  while(fgets(buf,1000,pfp) != NULL){
    if(buf[0] == '>')
      numSeq++;
    if(numSeq == 1)
      fprintf(qfp,"%s",buf);
    else if(numSeq == 2)
      fprintf(sfp,"%s",buf);
    else
      break;
  }
  free(buf);
  free(cmd);
  fclose(qfp);
  fclose(sfp);
  pclose(pfp);
}
